# ###############################################################
# BotSlay_Python v 1.0
# Author: Neptune
# Date: 08/07/2010
# ###############################################################
# MOD Outline:
#
# each time someone dies, check if there are any more bots or human players
# if it's just bots, kill 'em dead!
# ###############################################################

# Import the modules we need
import es
import playerlib
import gamethread

# Initialize variables used by the mod

# Name
info = es.AddonInfo() 
info.name     = "Neptune's Botslay" 
info.version  = "1.0"
info.url      = "http://cmgsourceclan.com/" 
info.basename = "neptune_botslay" 
info.author   = "Neptune"
modName = "[#greenNeptune's Bot Slay#default]"


# Actions to take when the mod is loaded
def load():
 global roundOnlyBots, alert
 es.msg("#multi", modName + " loaded.")
 roundOnlyBots = checkBots(0)
 alert = 0

def round_start(event_var):
 global roundOnlyBots, alert
 alert = 0
 roundOnlyBots = checkBots(0)
 
# Wait for a player to die or leave and check for bots only
def player_death(event_var):
 if (roundOnlyBots == 0):
  slayBots(int(event_var['userid']))
#  gamethread.delayed(1, slayBots, (int(event_var['userid']))) 
def player_team(event_var):
  slayBots(int(event_var['userid'])) 
  
def checkBots(event_var):
 # Creates a list of Player objects using a filter
 myPlayerList = playerlib.getPlayerList('#alive, #human')
 playersLeft = len(myPlayerList)
# es.msg(event_var)
# es.msg(playersLeft)
 if ( not myPlayerList ):
  return 1
 elif ( int(len(myPlayerList)) == 1 and event_var > 0):
  for x in myPlayerList:
   if int(x) == int(event_var):
    return 1
   else:
    return 0
 else:
  #es.msg("There are  %i humane players left" %  (len(myPlayerList)))
  return 0
 myPlayerList.clear()
  
def slayBots(event_var):
 botList = checkBots(int(event_var))
 if (botList == 1):
  slayAlert(0)
  es.server.cmd("bot_kill")

def slayAlert(event_var):
 global alert
 if ( alert == 0 ):
  es.msg("#multi", modName + " Slaying bots to end the round.")
  alert = 1

# Actions to take as the mod is unloaded
def unload():
 es.msg("#multi",modName + " unloaded.")
 
